//makedoc7.cpp̃pNB()

#ifdef sparc
#	ifndef UNIX
#	define UNIX 1
#	endif
#endif


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//mingw32 + Vgui Ȋp(ĎH())
//#include <cstring.h>

//template<class A> A max(const A& a, const A& b) {return (a<b) ? b : a;}
#define max(a,b) ((a>b) ? a : b)

typedef unsigned char byte;
typedef unsigned long DWORD;
typedef unsigned short WORD;
#define DISP_BITS 11
#define COUNT_BITS 3

// all numbers in these structs are big-endian, MAC format
struct tDocHeader {
    char sName[32];		// 32 bytes
    DWORD dwUnknown1;	// 36
    DWORD dwTime1;		// 40
    DWORD dwTime2;		// 44
    DWORD dwTime3;		// 48
    DWORD dwLastSync;	// 52
    DWORD ofsSort;		// 56
    DWORD ofsCatagories;	// 60
    DWORD dwCreator;	// 64
    DWORD dwType;		// 68
    DWORD dwUnknown2;	// 72
    DWORD dwUnknown3;	// 76
    WORD  wNumRecs;		// 78
};
#define DOCHEADSZ 78

//0R[hځBʂwb_B
struct tDicRecord0 {
    DWORD DataNum;	//P͉H
    DWORD inDataMaxLen;	//ϊO̒P̍ő咷
    DWORD inDataRecs; 	//4096ɕϊO̒P͉͂H
    DWORD outDataOffSet; //ϊ̒P̎n܂郌R[h
    DWORD outDataMaxLen;	// ϊ̒P̑傫
    DWORD outDataRecs; 	// 4096ɉ͂H
    DWORD maxRatio; //ň̕ϊRXg
};

//rbOGfBẢ@
////////////// utilities //////////////////////////////////////

WORD SwapWord21(WORD r)
{
    return (r>>8) + (r<<8);
}
WORD SwapWord12(WORD r)
{
    return r;
}
DWORD SwapLong4321(DWORD r)
{
    return  ((r>>24) & 0xFF) + (r<<24) + ((r>>8) & 0xFF00) + ((r<<8) & 0xFF0000);
}
DWORD SwapLong1234(DWORD r)
{
    return r;
}

WORD (*SwapWord)(WORD r) = NULL;
DWORD (*SwapLong)(DWORD r) = NULL;

// copy bytes into a word and double word and see how they fall,
// then choose the appropriate swappers to make things come out
// in the right order.
int SwapChoose()
{
    union { char b[2]; WORD w; } w;
    union { char b[4]; DWORD d; } d;

    strncpy(w.b, "\1\2", 2);
    strncpy(d.b, "\1\2\3\4", 4);

    if (w.w == 0x0201)
        SwapWord = SwapWord21;
    else if (w.w == 0x0102)
        SwapWord = SwapWord12;
    else
        return 0;

    if (d.d == 0x04030201)
        SwapLong = SwapLong4321;
    else if (d.d == 0x01020304)
        SwapLong = SwapLong1234;
    else
        return 0;

    return 1;
}

void out_word(short w, FILE* fout)
{
    short m = SwapWord(w);
    fwrite(&m,2,1,fout);
}
void out_long(long d, FILE* fout)
{
    long d1 = SwapLong(d);
    fwrite(&d1,4,1,fout);
}

int
main(int argc, char** argv)
//1: ϊPꐔ
//2: ϊO̒Pꂽt@C
//3: ϊ̒Pꂽt@C
//4: 鎫̃t@C
//5: Database(PalmOS猩O)
{
    int iArg=1;
    FILE* fin1;
    FILE* fin2;
    FILE* fout;
    tDocHeader head1;
    DWORD storySize;

    //̃`FbN
    if (argc != 6)
    {
        printf("invalid arguments\nargc=%d\n",argc);
        exit(2);
    }

    sscanf(argv[iArg],"%ld",&storySize);
    iArg++;

    fin1 = fopen(argv[iArg],"r");
    fin2 = fopen(argv[iArg+1],"r");
    fout = fopen(argv[iArg+2],"wb");
    if (fin1==0 || fin2 ==0 || fout==0)
    {
        printf("problem opening files\n");
        exit(2);
    }
    if ( ! SwapChoose()) {
        printf("\nfailed to select proper byte swapping algorithm");
#if UNIX
        printf("\n");
#endif
        exit(1);
    }


    DWORD	x;
    WORD w;
    long	recSize = 4096;
    DWORD		z,numRecs;

    sprintf(head1.sName,"%.31s",argv[iArg+3]);
    head1.sName[31] = 0;

    //悭킩񂪂Ɨǂ炵B
    /*LocalWrite just writes to the new file the number of bytes starting at the passed pointer*/

    head1.dwUnknown1 = 0;
    strncpy((char *)&head1.dwTime1, "\x06\xD1\x44\xAE", 4);
    strncpy((char *)&head1.dwTime2, "\x06\xD1\x44\xAE", 4);
    head1.dwTime3 = 0;
    head1.dwLastSync = 0;
    head1.ofsSort = 0;
    head1.ofsCatagories = 0;
    //wb_̏Ԃt̂悤ȋCEEE ^^;
    strncpy((char *)&head1.dwCreator, "Data", 4);	// database creator
    strncpy((char *)&head1.dwType, "DDNO", 4);	// database type
    head1.dwUnknown2 = 0;
    head1.dwUnknown3 = 0;

    tDicRecord0 rec0;

    rec0.DataNum=storySize;
    rec0.inDataMaxLen=0;
    rec0.outDataMaxLen=0;
    rec0.outDataOffSet=0;
    rec0.maxRatio=0;

    //̓ǂݍ
    char inbuf1[128];
    char inbuf2[128];
    inbuf1[0] = inbuf2[0] = 0;
    double MaxRatio=0.0;
    //ő咷ƍňRXg̃XL
    for (int i=0;i<storySize;i++)
    {
        fgets(inbuf1,127,fin1);
        fgets(inbuf2,127,fin2);
        rec0.inDataMaxLen = (rec0.inDataMaxLen > strlen(inbuf1)-1)
                            ?rec0.inDataMaxLen :strlen(inbuf1)-1 ;
        rec0.outDataMaxLen = (rec0.outDataMaxLen > strlen(inbuf2)-1)
                             ?rec0.outDataMaxLen :strlen(inbuf2)-1 ;
        MaxRatio = MaxRatio > (double)(strlen(inbuf2)-1)/(strlen(inbuf1)-1) ?
                   MaxRatio : (double)(strlen(inbuf2)-1)/(strlen(inbuf1)-1);
        MaxRatio = MaxRatio > (double)(strlen(inbuf1)-1)/(strlen(inbuf2)-1) ?
                   MaxRatio : (double)(strlen(inbuf1)-1)/(strlen(inbuf2)-1);
    }
    rec0.maxRatio=(long)MaxRatio+1;
    printf("inMaxLen=%ld\noutMaxLen=%ld\nMaxRatio=%ld\nMaxRatio=%lf\n",rec0.inDataMaxLen,rec0.outDataMaxLen,rec0.maxRatio,MaxRatio);

    rec0.inDataMaxLen++;
    rec0.outDataMaxLen++;	//for NULL
    rec0.inDataRecs=  recSize/rec0.inDataMaxLen;
    rec0.outDataRecs=recSize/rec0.outDataMaxLen;

    int inDataAmari=recSize%rec0.inDataMaxLen;
    int outDataAmari=recSize%rec0.outDataMaxLen;
    z=1;
    z+=rec0.DataNum/rec0.inDataRecs+1;
    rec0.outDataOffSet=z;
    z+=(rec0.DataNum/rec0.outDataRecs+1);

    numRecs = z;
    head1.wNumRecs = SwapWord(z);		//  the number of records to follow
    fwrite(&head1,1,DOCHEADSZ,fout);
    unsigned long index;
    index = 0x406F8000;		// the pattern for attributes=dirty + unique_id=0x6f8000
    x = 0x50L + (long) z * 8;

    out_long(x,fout);		// start writing the record offsets
    out_long(index,fout);
    index++;
    z--;

    while(z--) {
        out_long(x,fout);		//more record offsets
        out_long(index++,fout);		// the attributes + ID's
        x += 0x1000L;
    }
    out_word(0,fout);

    long inDataMaxLen=rec0.inDataMaxLen;
    long outDataMaxLen=rec0.outDataMaxLen;
    long DataNum=rec0.DataNum;
    long inDataRecs=rec0.inDataRecs;
    long outDataRecs=rec0.outDataRecs;
    //rbgւȂ\̂ɔ[߂
    rec0.DataNum=SwapLong(rec0.DataNum);
    rec0.inDataMaxLen=SwapLong(rec0.inDataMaxLen);
    rec0.inDataRecs=SwapLong(rec0.inDataRecs);
    rec0.outDataOffSet=SwapLong(rec0.outDataOffSet);
    rec0.outDataMaxLen=SwapLong(rec0.outDataMaxLen);
    rec0.outDataRecs=SwapLong(rec0.outDataRecs);
    rec0.maxRatio=SwapLong(rec0.maxRatio);

    fseek(fout, 0x4E, SEEK_SET);
    out_long(0x4E+8*numRecs,fout);
    fseek(fout, 0x4E+8*numRecs, SEEK_SET);
    fwrite(&rec0,1,sizeof(rec0),fout);

    int n = recSize;
    // dump the whole story into the new file
    int recNum = 1;
    printf("\n");

    int wordSum;
    char * indata = new char[inDataMaxLen];
    char * outdata = new char[outDataMaxLen];
    char * ibuf = new char[4096];
    for (int i=0; i<4096;i++)
        ibuf[i]=0;
    fseek(fin1,0,SEEK_SET);
    fseek(fin2,0,SEEK_SET);

    //f[^o
    while(recNum < DataNum/inDataRecs+2)
    {
        long pos;
        pos = ftell(fout);
        fseek(fout, 0x4E + 8*recNum, SEEK_SET);//4E = end of header
        if (recNum!=numRecs) out_long(pos,fout);//write offset to header
        fseek(fout, pos, SEEK_SET);
        wordSum=0;
        while (wordSum < inDataRecs)
        {
            for (int i=0; i<inDataMaxLen; i++)
                indata[i] = 0;
            n = fscanf(fin1,"%s\n",indata);
            if (n==0)
                break;
            memmove(ibuf+wordSum*inDataMaxLen,indata,inDataMaxLen);
            wordSum++;
        }
        fwrite(ibuf,1,4096,fout);
        recNum++;
    }
    while(recNum < numRecs)
    {
        long pos;
        pos = ftell(fout);
        fseek(fout, 0x4E + 8*recNum, SEEK_SET);//4E = end of header
        if (recNum!=numRecs) out_long(pos,fout);//write offset to header
        fseek(fout, pos, SEEK_SET);
        wordSum=0;
        while (wordSum < outDataRecs)
        {
            for (int i=0; i<outDataMaxLen; i++)
                outdata[i] = 0;
            n = fscanf(fin2,"%s\n",outdata);
            if (n==0)
                break;
            memmove(ibuf+wordSum*outDataMaxLen,outdata,outDataMaxLen);
            wordSum++;
        }
        fwrite(ibuf,1,4096,fout);
        recNum++;
    }

    fclose(fin1);
    fclose(fin2);
    fclose(fout);

    exit(0);
}
